function y = GCTRflt(key,icb,x,sn256)
%This is a modified standard AES-GCM implementation, modified by applying a patented 256-state FLT
% transformation and a patent pending radix-256 transformation
% While the basic AES-GCM implementation is IP-free, this particular
% implementation is not!
% You are only allowed to apply this program for
% testing/trial/education/research purposes. 
% Use for operational encryption is strictly prohibited.
% Certain aspects of the present implementation may be covered by patents:
% US 12,143,468; US 11,093,213; 12,056,549;US 11,336,425 and pending
% patent applications.

%input: key is hex,icb is binary array, x binary array
%output: y is binary array
if isempty(x)
    y=[];
    return;
end
n=ceil(length(x)/128);
cb(1,:)=icb;
for i=2:n
    cb(i,:)=inc(32,cb(i-1,:));
end
y=[];
for i=1:n-1
    y=[y,xor(x((i-1)*128+1:i*128),Cipherflt(key,cb(i,:),sn256))];
end
l=length(x)-(n-1)*128;
c=Cipherflt(key,cb(n,:),sn256);
y=[y,xor(x((n-1)*128+1:end),c(1:l))];